﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;

// By Rien

namespace SubnauticaPatcher
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        static string appPath = Path.GetDirectoryName(Application.ExecutablePath);
        static string filePath = appPath + @"\Subnautica_Data\Managed\Assembly-CSharp.dll";
        static string backupPath = appPath + @"\Subnautica_Data\Managed\Assembly-CSharp.dll_BACKUP";

        // Positions are the hex positions of the changes in decimal
        // Much faster than searching for them

        int MurkinessCalcPosition = 1494608;
        byte[] MurkinessCalc100 = { 0x02, 0x7B, 0xA1, 0x38, 0x00, 0x04, 0x22, 0x00, 0x00, 0xC8, 0x42, 0x5B, 0x0A }; // STOCK - for reference
        byte[] MurkinessCalc75 = { 0x02, 0x7B, 0xA1, 0x38, 0x00, 0x04, 0x22, 0x00, 0x00, 0x96, 0x42, 0x5B, 0x0A }; // DARK
        byte[] MurkinessCalc50 = { 0x02, 0x7B, 0xA1, 0x38, 0x00, 0x04, 0x22, 0x00, 0x00, 0x48, 0x42, 0x5B, 0x0A }; // DARKER
        byte[] MurkinessCalc25 = { 0x02, 0x7B, 0xA1, 0x38, 0x00, 0x04, 0x22, 0x00, 0x00, 0xC8, 0x41, 0x5B, 0x0A }; // DARKEST

        // Very basic error handling
        
        private void backup_button_Click(object sender, EventArgs e)
        {
            try
            {
                File.Copy(filePath, backupPath, true);
                MessageBox.Show("Backup Made", "Done", MessageBoxButtons.OK);
            } catch
            {
                MessageBox.Show("Something went wrong :(", "Error", MessageBoxButtons.OK);
            }
        }

        private void patch_button_Click(object sender, EventArgs e)
        {
            try
            {
                using (var stream = new FileStream(filePath, FileMode.Open, FileAccess.ReadWrite))
                {
                    //Patch MurkinessCalc
                    stream.Position = MurkinessCalcPosition;
                    if (murk_dark.Checked)
                    {
                        stream.Write(MurkinessCalc75, 0, MurkinessCalc75.Length);
                    }
                    else if (murk_darker.Checked)
                    {
                        stream.Write(MurkinessCalc50, 0, MurkinessCalc50.Length);
                    }
                    else if (murk_darkest.Checked)
                    {
                        stream.Write(MurkinessCalc25, 0, MurkinessCalc25.Length);
                    }
                }
                MessageBox.Show("Patching Finished!", "Done", MessageBoxButtons.OK);
            } catch
            {
                MessageBox.Show("Something went wrong :(", "Error", MessageBoxButtons.OK);
            }
        }

        private void restore_button_Click(object sender, EventArgs e)
        {
            try
            {
                File.Copy(backupPath, filePath, true);
                MessageBox.Show("Backup Restored", "Done", MessageBoxButtons.OK);
            }
            catch
            {
                MessageBox.Show("Something went wrong :(", "Error", MessageBoxButtons.OK);
            }
        }

        private void murk_info_Click(object sender, EventArgs e)
        {
            string info = "This changes the murkiness calculation \n" +
                "\n" +
                "Normal Value: float d = this.murkiness / 100f\n" +
                "Dark Value: float d = this.murkiness / 75f\n" +
                "Darker Value: float d = this.murkiness / 50f\n" +
                "Darkest Value: float d = this.murkiness / 25f\n" +
                "\n";
            MessageBox.Show(info, "Murkiness Calculation", MessageBoxButtons.OK);
        }

        // This probably isn't the best way to do this. If Subnautica is set to run as Admin, it fails. Also doesn't load Steam Overlay.

        private void run_game_Click(object sender, EventArgs e)
        {
            try
            {
                Process.Start(appPath + @"\Subnautica.exe");
            } catch
            {
                MessageBox.Show("Can't find Subnautica.exe", "Error", MessageBoxButtons.OK);
            }
        }

        
    }
}
